#ifndef __item_h__
#define __item_h__

#include <stdio.h>

enum item_shape_e
{
    Circle = 0,
    Box
};

typedef enum item_shape_e item_shape_t;

struct item_s
{
    struct item_s *prev;
    struct item_s *next;

    unsigned id;

    // dynamic stuff
    struct
    {
	unsigned dynamic     : 1;
	unsigned collectable : 1;
	unsigned removable   : 1;
    };
    double position[2];
    double angle;
    void * dynamic_data;

    // render stuff
    item_shape_t shape;
    union
    {
	struct
	{
	    double radius;
	    double radius_copy;
	};
	struct
	{
	    double width;
	    double height;
	};
    };
    double color[4];
    char   image[1024];
    void * render_data;
};

typedef struct item_s item_t;

item_t * item_alloc(item_t ** items_head);
void     item_free (item_t * item, item_t ** items_head);
void     item_print(item_t * item, FILE * fp, unsigned print_all);

#endif /* __item_h__ */
