#include "world.h"
#include "dynamic.h"

int main(int argc, char **argv)
{
    double dt = 0.016;
    world_t * world = NULL;
    dynamic_t * dynamic = NULL;
    unsigned count = 0xFFF;

    world = world_alloc_from_random(128);

    // alloc subsystems
    dynamic = dynamic_alloc();

    // init subsystems
    dynamic_init(dynamic, world);

    while(count--)
    {
	dynamic_update(dynamic, dt);
    } 

    // kill subsystems
    dynamic_kill(dynamic);

    // free subsystems
    dynamic_free(dynamic);

    // free world and items
    world_free(world);

    return 0;
}
