#include <assert.h>

#include "item.h"

int main(int argc, char **argv)
{
    item_t * items_head = NULL;
    item_t * item_1;
    item_t * item_2;
    item_t * item_3;
    item_t * item_4;

    item_1 = item_alloc(&items_head);
    assert(item_1 == items_head);
    assert(item_1->prev == NULL);
    assert(item_1->next == NULL);
    
    item_1->id = 1;

    item_2 = item_alloc(&items_head);
    assert(item_2 == items_head);
    assert(item_2->prev == NULL);
    assert(item_2->next == item_1);
    assert(item_1->prev == item_2);
    assert(item_1->next == NULL);
    
    item_2->id = 2;

    item_3 = item_alloc(&items_head);
    assert(item_3 == items_head);
    assert(item_3->prev == NULL);
    assert(item_3->next == item_2);
    assert(item_2->prev == item_3);
    assert(item_2->next == item_1);
    assert(item_1->prev == item_2);
    assert(item_1->next == NULL);
    
    item_3->id = 3;

    item_4 = item_alloc(&items_head);
    assert(item_4 == items_head);
    assert(item_4->prev == NULL);
    assert(item_4->next == item_3);
    assert(item_3->prev == item_4);
    assert(item_3->next == item_2);
    assert(item_2->prev == item_3);
    assert(item_2->next == item_1);
    assert(item_1->prev == item_2);
    assert(item_1->next == NULL);
    
    item_4->id = 4;

    item_print(items_head, stdout, 1);

    item_free(item_4, &items_head);
    assert(item_3 == items_head);
    assert(item_3->prev == NULL);
    assert(item_3->next == item_2);
    assert(item_2->prev == item_3);
    assert(item_2->next == item_1);
    assert(item_1->prev == item_2);
    assert(item_1->next == NULL);

    item_free(item_2, &items_head);
    assert(item_3 == items_head);
    assert(item_3->prev == NULL);
    assert(item_3->next == item_1);
    assert(item_1->prev == item_3);
    assert(item_1->next == NULL);

    item_free(item_3, &items_head);
    assert(item_1 == items_head);
    assert(item_1->prev == NULL);
    assert(item_1->next == NULL);

    item_free(item_1, &items_head);
    assert(NULL == items_head);

    return 0;
}
