#include <assert.h>

#include "world.h"

int main(int argc, char **argv)
{
    world_t * world = NULL;

    /* test random */
    world = world_alloc_from_random(64);
    assert(world);
    assert(world->items_head);
    assert(world->dynamic_data == NULL);
    assert(world->render_data == NULL);

    world_print(world, stdout);

    world_free(world);

    /* test xml */
    world = world_alloc_from_xml("level_test.xml");
    assert(world);
    assert(world->items_head);
    assert(world->dynamic_data == NULL);
    assert(world->render_data == NULL);

    world_print(world, stdout);

    world_free(world);

    /* test xml corrupt */
    world = world_alloc_from_xml("level_test_fail.xml");
    assert(world == NULL);

    return 0;
}
