#ifndef __world_h__
#define __world_h__

#include <stdio.h>

#include "item.h"

struct world_s
{
    // dynamic stuff
    double gravity[2];
    void * dynamic_data;

    // render stuff
    double width;
    double height;
    double color[4];
    char   image[1024];
    void * render_data;

    // list of items
    item_t * items_head;
};

typedef struct world_s world_t;

world_t * world_alloc_from_random(void);
world_t * world_alloc_from_xml(const char * filename);
void      world_free(world_t * world);
int       world_check(world_t * world);
void      world_print(world_t * world, FILE * fp);

#endif /* __world_h__ */
